<?php

namespace EventPortal\Domain\Handlers;

use Closure;
use EventPortal\Domain\Form\Payload;

class FindOrCreateModel
{
    /** @var string */
    public $field;

    public function __construct(string $findModelByField)
    {
        $this->field = $findModelByField;
    }

    /**
     * @return mixed
     */
    public function __invoke(Payload $payload, Closure $next)
    {
        $model = $payload->getModel()->firstOrCreate(
            [$this->field => $payload->getInput($this->field)],
            $payload->getInput()
        );

        $payload->replaceModel($model);

        return $next($payload);
    }
}
